﻿using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;

using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Controls;
using DevExpress.XtraEditors.ViewInfo;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.checkedListBoxControl1.ValueMember   = "ID";
            this.checkedListBoxControl1.DisplayMember = "Name";
            this.checkedListBoxControl1.DataSource    = GetDataSoure();

            this.checkedListBoxControl2.ValueMember   = "ID";
            this.checkedListBoxControl2.DisplayMember = "Name";
            this.checkedListBoxControl2.DataSource    = GetDataSoure();

            this.checkedListBoxControl2.ItemChecking += checkedListBoxControl_ItemChecking;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 체크 리스트 박스 컨트롤 항목 체크할 경우 처리하기 - checkedListBoxControl_ItemChecking(sender, e)

        /// <summary>
        /// 체크 리스트 박스 컨트롤 항목 체크할 경우 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void checkedListBoxControl_ItemChecking(object sender, ItemCheckingEventArgs e)
        {
            CheckedListBoxControl checkedListBoxControl = sender as CheckedListBoxControl;

            CheckedListBoxViewInfo checkedListBoxViewInfo = checkedListBoxControl.GetViewInfo() as CheckedListBoxViewInfo;

            Point point = checkedListBoxControl.PointToClient(Control.MousePosition);

            CheckedListBoxViewInfo.CheckedItemInfo checkedItemInfo = checkedListBoxViewInfo.GetItemInfoByPoint(point) as CheckedListBoxViewInfo.CheckedItemInfo;

            e.Cancel = checkedItemInfo.Bounds.Contains(point);
           
            /*
            checkedItemInfo.CheckArgs.GlyphRect : 체크 박스 글리프 사각형
            checkedItemInfo.TextRect            : 텍스트 영역 사각형
            */
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region 데이터 소스 구하기 - GetDataSoure()

        /// <summary>
        /// 데이터 소스 구하기
        /// </summary>
        /// <returns>데이터 소스</returns>
        private object GetDataSoure()
        {
            List<Student> list = new List<Student>();

            for(int i = 0; i < 100; i++)
            {
                list.Add(new Student { ID = (i + 1).ToString(), Name = "학생 " + (i + 1).ToString(), Grade = (i % 6 + 1) });
            }

            return list;
        }

        #endregion
    }
}